client/New()
	CheckHost()
	world<<"[src] has logged in."
	..()
client/proc/CheckHost()
	if(address==null||address==world.address)
		for(var/X in typesof(/mob/admin/verb)) verbs+=X
mob
	player
		icon = 'icons.dmi'
		icon_state = "yoshi"
		density = 1
	verb
		World_Say(t as text)
			set desc = "Out Of Character. Non-RP talk."
			if(src.mute == 1)
				return
			if(src.saycount >= 5)
				world<<"[src] is auto-muted."
				src.mute = 1
				sleep(600)
				world<<"[src] is auto-unmuted."
				src.mute = 0
				return
			else
				if(t == ""||t == null||t == " ")
					return
				src.saycount += 1
				world<<"<B>[src] world says :</B> [html_encode(t)]"
				sleep(10)
				src.saycount -= 1
		Wemote(t as text)
			if(src.mute == 1)
				return
			if(src.saycount >= 5)
				world<<"[src] is auto-muted."
				src.mute = 1
				sleep(600)
				world<<"[src] is auto-unmuted."
				src.mute = 0
				return
			else
				src.saycount += 1
				if(t == ""||t == null||t == " ")
					return
				src.saycount += 1
				world<<"[src] [html_encode(t)]"
				sleep(10)
				src.saycount -= 1
		Say(t as text)
			if(src.mute == 1)
				return
			if(src.saycount >= 5)
				world<<"[src] is auto-muted."
				src.mute = 1
				sleep(600)
				world<<"[src] is auto-unmuted."
				src.mute = 0
				return
			else
				if(t == ""||t == null||t == " ")
					return
				src.saycount += 1
				view(10)<<"[src] says : [html_encode(t)]"
				sleep(10)
				src.saycount -= 1
		Emote(t as text)
			if(src.mute == 1)
				return
			if(src.saycount >= 5)
				world<<"[src] is auto-muted."
				src.mute = 1
				sleep(600)
				world<<"[src] is auto-unmuted."
				src.mute = 0
				return
			else
				if(t == ""||t == null||t == " ")
					return
				src.saycount += 1
				view(10)<<"[src] [html_encode(t)]"
				sleep(10)
				src.saycount -= 1
		Who()
			var/mob/M
			src << "Players:"
			for(M in world)
				if(M.key)
					if(M.afk == 0)
						src << "[M.key] ; [M.z]"
					if(M.afk == 1)
						src << "[M.key] ; [M.z] (away)"
world
	mob = /mob/player
	name = "Crossing Remake"
	status = "Remade Crossing, Join the old fun!"
	hub = "Hiddeknight.CrossingRemake"
mob/var
	lives = 3
	loadz;loadx;loady
	afk = 0
	saycount = 0
	mute = 0
mob/Bump(var/atom/O)//when a player bumbs into an object
	if(O.name=="Log")//if the objects name is Log
		usr.loc=O.loc//it puts the player on the log
area
	levelup
		Entered(mob/M in world)
			usr.z += 1
			usr.x = 1
			usr.y = 6
			usr<<"<b>level [usr.z]!</b>"
			if(usr.z >= 20)
				usr<<"You have beaten Crossing Remake! Feel free to remake the remake..."
obj/Log//makes the log
	icon='icons.dmi'//sets the logs icon
	icon_state=""//sets it icon state
	density=1//sets it density
	New()//calls this when a new log is made
		movedown()//calls the move down proc
	proc/movedown()//the move down proc
		set background=1//makes it run in the bg so it wont cause lag
		while(src)//while the log iz there, not deleted and such...
			for(var/mob/M in world)//sets all the players in the world as M
				if(M.loc==src.loc&&M!=src)//if the players location is the same as the log...
					M.loc=locate(src.x,src.y-1,src.z)//then it moves the player down
			src.loc=locate(src.x,src.y-1,src.z)//this moves the log down
			sleep(12)//sleeps...
			if(src.y==1)//if the log iz at the bottom of the screen
				for(var/mob/M in world)//sets players again
					if(M.loc==src.loc&&M!=src)//checks players again
						if(M.key)
							M.loc=locate(1,1,1)//if there on the log it puts em back at the top
				src.y=10//puts the log at the top
				sleep(rand(1,20))//sleeps
		spawn(1)//spawns... prevents infinite loops
			movedown()//calls the move down proc again
mob
	Write(savefile/F)
		src.loady = src.y
		src.loadx = src.x
		src.loadz = src.z
		F["loady"] << src.loady
		F["loadx"] << src.loadx
		F["loadz"] << src.loadz
		..()
	Read(savefile/F)
		F["loady"] >> src.loady
		F["loadx"] >> src.loadx
		F["loadz"] >> src.loadz
		src.x = src.loadx
		src.y = src.loady
		src.loc = locate(src.loadx,src.loady,src.loadz)
turf
	grass
		icon = 'icons.dmi'
		icon_state = "grass"
	water
		density=0
		icon='icons.dmi'
		icon_state="water"
		Entered(var/mob/M)
			if(M.key)
				M<<"You drowned"
				M.loc=locate(1,1,usr.z)
				if(usr.lives >= 1)
					usr.x = 1
					usr.y = 6
					usr.lives -= 1
					usr<<"You drown in the water. You have [usr.lives] lives left!"
				if(usr.lives <= 0)
					usr.z = 1
					usr.x = 1
					usr.y = 6
					usr.lives = 3
					usr<<"You have run out of lives..."
	rock
		icon = 'icons.dmi'
		icon_state = "rock"
	dam
		density = 1
		icon = 'icons.dmi'
		icon_state = "dam"
