mob/admin
	verb
		Goto(mob/M in world)
			set category = "GM"
			usr.loc = M.loc
			M << "[src] instantly appears before you!"
			src << "You appear before [M]"
		Play_Music(M as sound)
			set category = "GM"
			world << sound(M)
			world<<"[usr] has played [M]"
		Play_Music_To_View(M as sound)
			set category = "GM"
			view(11)<< sound(M)
			view(11)<<"[usr] has played [M]"
		Mute(mob/M in world)
			set category = "GM"
			if(M.mute==0)
				M.mute=1
				world << "[M] has been muted by [usr]"
				return
			if(M.mute==1)
				M.mute=0
				world<<"[M] has been unmuted by [usr]"
				return
		Bring(mob/M in world)
			set category = "GM"
			if(M.afk)
				usr<<"They are AFK, you cant summon them."
			if(M.key)
				M.loc = usr.loc
				M << "You have been summoned by [usr]"
				usr << "You have summoned [M]"
			else
				usr<<"You can only summon players"
		ChangeName(mob/M in world)
			set category = "GM"
			src<<"Changing [M]'s name."
			var/newname = input("Name","Name","")
			M.name = newname
			M<<"<b>Your new name is [newname]."
		ChangeWorldName()
			set category = "GM"
			world.name = input("What is the new world name?","Change World Name",world.name)
		ChangeWorldStatus()
			set category="GM"
			world.status = input("What is the new world status?","Change World Status",world.status)
		Announce(message as message)
			set category = "GM"
			set name = "Announce"
			set desc = "(message) Announce something to all players logged in"
			for(var/client/C)
				C.mob << "<hr><center><font color=red><b>Announcement From [src]:</b><br>[message]</font></center><hr>"
		Reboot()
			set category = "GM"
			world << "<b><font color = red>World will reboot in 30 seconds! - [usr]"
			sleep(300)
			world.Reboot()
		Shutdown()
			set category = "GM"
			world << "<b><font color = red>Server will shut down in 30 seconds! - [usr]"
			sleep(300)
			del world
		Boot(mob/M in world)
			set category="GM"
			switch(alert("Disconnect [M]!?","Disconnect Player","Yes","No"))
				if("Yes")
					if(M.key)
						if(M.key == "Hiddeknight"||M.key == "D4RK3 54B3R")
							usr<<"You can only disconect players with lower level GM then you!"
							M<<"[usr] tried to disconect you."
						else
							world<<"[M] has been booted by [usr]"
							del M
					else
						usr<<"You can only disconect players"
		Create(O as null|anything in typesof(/obj,/mob,/turf))
			set category = "GM"
			set name = "Create"
			set desc="(object) Create a new mob, or obj"
			if(!O)
				return
			var/item = new O(usr.loc)
			usr << "You create \a [item:name]."
			view() << "\The [item:name] appears infront of [usr]."
		Edit(obj/O as obj|mob|turf|area in world)
			set category = "GM"
			set name = "Edit"
			set desc="(target) Edit a target item's variables"
			var/variable = input("Which var?","Var") in O.vars
			var/default
			var/typeof = O.vars[variable]
			var/dir
			if(isnull(typeof))
				usr << "Unable to determine variable type."
			else if(isnum(typeof))
				usr << "Variable appears to be <b>NUM</b>."
				default = "num"
				dir = 1
			else if(istext(typeof))
				usr << "Variable appears to be <b>TEXT</b>."
				default = "text"
			else if(isloc(typeof))
				usr << "Variable appears to be <b>REFERENCE</b>."
				default = "reference"
			else if(isicon(typeof))
				usr << "Variable appears to be <b>ICON</b>."
				typeof = "\icon[typeof]"
				default = "icon"
			else if(istype(typeof,/atom) || istype(typeof,/datum))
				usr << "Variable appears to be <b>TYPE</b>."
				default = "type"
			else if(istype(typeof,/list))
				usr << "Variable appears to be <b>LIST</b>."
				usr << "*** Warning!  Lists are uneditable in s_admin! ***"
				default = "cancel"
			else if(istype(typeof,/client))
				usr << "Variable appears to be <b>CLIENT</b>."
				usr << "*** Warning!  Clients are uneditable in s_admin! ***"
				default = "cancel"
			else
				usr << "Variable appears to be <b>FILE</b>."
				default = "file"
			usr << "Variable contains: [typeof]"
			if(dir)
				switch(typeof)
					if(1)
						dir = "NORTH"
					if(2)
						dir = "SOUTH"
					if(4)
						dir = "EAST"
					if(8)
						dir = "WEST"
					if(5)
						dir = "NORTHEAST"
					if(6)
						dir = "SOUTHEAST"
					if(9)
						dir = "NORTHWEST"
					if(10)
						dir = "SOUTHWEST"
					else
						dir = null
				if(dir)
					usr << "If a direction, direction is: [dir]"
			var/class = input("What kind of variable?","Variable Type",default) in list("text",
				"num","type","reference","icon","file","restore to default","cancel")
			switch(class)
				if("cancel")
					return
				if("restore to default")
					O.vars[variable] = initial(O.vars[variable])
				if("text")
					O.vars[variable] = input("Enter new text:","Text",\
						O.vars[variable]) as text
				if("num")
					O.vars[variable] = input("Enter new number:","Num",\
						O.vars[variable]) as num
				if("type")
					O.vars[variable] = input("Enter type:","Type",O.vars[variable]) \
						in typesof(/obj,/mob,/area,/turf)
				if("reference")
					O.vars[variable] = input("Select reference:","Reference",\
						O.vars[variable]) as mob|obj|turf|area in world
				if("file")
					O.vars[variable] = input("Pick file:","File",O.vars[variable]) \
						as file
				if("icon")
					O.vars[variable] = input("Pick icon:","Icon",O.vars[variable]) \
						as icon
mob/GM/verb/Disconnect(mob/M in world)
	set category="GM"
	switch(alert("Disconnect [M]!?","Disconnect Player","Yes","No"))
		if("Yes")
			if(M.key)
				if(M.GM<usr.GM)
					world<<"[M] has been booted by [usr]"
					del M
				else
					usr<<"You can only disconect players with lower level GM then you!"
					M<<"[usr] tried to disconect you"
			else
				usr<<"You can only disconect players"
mob/var/GM=0